Package org.apache.commons.fileupload2.core

# Class DiskFileItem

java.lang.Object
org.apache.commons.fileupload2.core.DiskFileItem

All Implemented Interfaces:
  `FileItem<DiskFileItem>`, `FileItemHeadersProvider<DiskFileItem>`

public final class DiskFileItem extends Object implements FileItem<DiskFileItem>
The default implementation of the `FileItem` interface.

After retrieving an instance of this class from a `DiskFileItemFactory` instance (see `org.apache.commons.fileupload2.core.servlet.ServletFileUpload #parseRequest(javax.servlet.http.HttpServletRequest)`), you may either request all contents of file at once using `get()` or request an `InputStream` with `getInputStream()` and process the file without attempting to load it into memory, which may come handy with large files.

Temporary files, which are created for file items, should be deleted later on. The best way to do this is using a `FileCleaningTracker`, which you can set on the `DiskFileItemFactory`. However, if you do use such a tracker, then you must consider the following: Temporary files are automatically deleted as soon as they are no longer needed. (More precisely, when the corresponding instance of `File` is garbage collected.) This is done by the so-called reaper thread, which is started and stopped automatically by the `FileCleaningTracker` when there are files to be tracked. It might make sense to terminate that thread, for example, if your web application ends. See the section on "Resource cleanup" in the users guide of Commons FileUpload.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `DiskFileItem.Builder`
  Builds a new `DiskFileItem` instance.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Charset`
  `DEFAULT_CHARSET`
  Default content charset to be used when no explicit charset parameter is provided by the sender.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DiskFileItem.Builder`
  `builder()`
  Constructs a new `DiskFileItem.Builder`.
  `static String`
  `checkFileName(String fileName)`
  Tests if the file name is valid.
  `DiskFileItem`
  `delete()`
  Deletes the underlying storage for a file item, including deleting any associated temporary disk file.
  `byte[]`
  `get()`
  Gets the contents of the file as an array of bytes.
  `Charset`
  `getCharset()`
  Gets the content charset passed by the agent or `null` if not defined.
  `Charset`
  `getCharsetDefault()`
  Gets the default charset for use when no explicit charset parameter is provided by the sender.
  `String`
  `getContentType()`
  Gets the content type passed by the agent or `null` if not defined.
  `String`
  `getFieldName()`
  Gets the name of the field in the multipart form corresponding to this file item.
  `FileItemHeaders`
  `getHeaders()`
  Gets the file item headers.
  `InputStream`
  `getInputStream()`
  Gets an `InputStream` that can be used to retrieve the contents of the file.
  `String`
  `getName()`
  Gets the original file name in the client's file system.
  `OutputStream`
  `getOutputStream()`
  Gets an `OutputStream` that can be used for storing the contents of the file.
  `Path`
  `getPath()`
  Gets the `Path` for the `FileItem`'s data's temporary location on the disk.
  `long`
  `getSize()`
  Gets the size of the file.
  `String`
  `getString()`
  Gets the contents of the file as a String, using the default character encoding.
  `String`
  `getString(Charset charset)`
  Gets the contents of the file as a String, using the specified encoding.
  `protected Path`
  `getTempFile()`
  Creates and returns a `File` representing a uniquely named temporary file in the configured repository path.
  `boolean`
  `isFormField()`
  Tests whether or not a `FileItem` instance represents a simple form field.
  `boolean`
  `isInMemory()`
  Provides a hint as to whether or not the file contents will be read from memory.
  `DiskFileItem`
  `setCharsetDefault(Charset charset)`
  Sets the default charset for use when no explicit charset parameter is provided by the sender.
  `DiskFileItem`
  `setFieldName(String fieldName)`
  Sets the field name used to reference this file item.
  `DiskFileItem`
  `setFormField(boolean state)`
  Specifies whether or not a `FileItem` instance represents a simple form field.
  `DiskFileItem`
  `setHeaders(FileItemHeaders headers)`
  Sets the file item headers.
  `String`
  `toString()`
  Returns a string representation of this object.
  `DiskFileItem`
  `write(Path file)`
  Writes an uploaded item to disk.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_CHARSET

    public static final Charset DEFAULT_CHARSET
    Default content charset to be used when no explicit charset parameter is provided by the sender. Media subtypes of the "text" type are defined to have a default charset value of "ISO-8859-1" when received via HTTP.

- ## Method Details

  - ### builder

    public static DiskFileItem.Builder builder()
    Constructs a new `DiskFileItem.Builder`.
    Returns:
      a new `DiskFileItem.Builder`.

  - ### checkFileName

    public static String checkFileName(String fileName)
    Tests if the file name is valid. For example, if it contains a NUL characters, it's invalid. If the file name is valid, it will be returned without any modifications. Otherwise, throw an `InvalidPathException`.
    Parameters:
      `fileName` - The file name to check
    Returns:
      Unmodified file name, if valid.
    Throws:
      `InvalidPathException` - The file name is invalid.

  - ### delete

    public DiskFileItem delete() throws IOException
    Deletes the underlying storage for a file item, including deleting any associated temporary disk file. This method can be used to ensure that this is done at an earlier time, thus preserving system resources.
    Specified by:
      `delete` in interface `FileItem<DiskFileItem>`
    Returns:
      this
    Throws:
      `IOException` - if an error occurs.

  - ### get

    public byte[] get() throws UncheckedIOException
    Gets the contents of the file as an array of bytes. If the contents of the file were not yet cached in memory, they will be loaded from the disk storage and cached.
    Specified by:
      `get` in interface `FileItem<DiskFileItem>`
    Returns:
      The contents of the file as an array of bytes or `null` if the data cannot be read.
    Throws:
      `UncheckedIOException` - if an I/O error occurs.
      `OutOfMemoryError` - See `Files.readAllBytes(Path)`: If an array of the required size cannot be allocated, for example the file is larger that `2GB`

  - ### getCharset

    public Charset getCharset()
    Gets the content charset passed by the agent or `null` if not defined.
    Returns:
      The content charset passed by the agent or `null` if not defined.

  - ### getCharsetDefault

    public Charset getCharsetDefault()
    Gets the default charset for use when no explicit charset parameter is provided by the sender.
    Returns:
      the default charset

  - ### getContentType

    public String getContentType()
    Gets the content type passed by the agent or `null` if not defined.
    Specified by:
      `getContentType` in interface `FileItem<DiskFileItem>`
    Returns:
      The content type passed by the agent or `null` if not defined.

  - ### getFieldName

    public String getFieldName()
    Gets the name of the field in the multipart form corresponding to this file item.
    Specified by:
      `getFieldName` in interface `FileItem<DiskFileItem>`
    Returns:
      The name of the form field.
    See Also:
      - `setFieldName(String)`

  - ### getHeaders

    public FileItemHeaders getHeaders()
    Gets the file item headers.
    Specified by:
      `getHeaders` in interface `FileItemHeadersProvider<DiskFileItem>`
    Returns:
      The file items headers.

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Gets an `InputStream` that can be used to retrieve the contents of the file.
    Specified by:
      `getInputStream` in interface `FileItem<DiskFileItem>`
    Returns:
      An `InputStream` that can be used to retrieve the contents of the file.
    Throws:
      `IOException` - if an error occurs.

  - ### getName

    public String getName()
    Gets the original file name in the client's file system.
    Specified by:
      `getName` in interface `FileItem<DiskFileItem>`
    Returns:
      The original file name in the client's file system.
    Throws:
      `InvalidPathException` - The file name contains a NUL character, which might be an indicator of a security attack. If you intend to use the file name anyways, catch the exception and use `InvalidPathException.getInput()`.

  - ### getOutputStream

    public OutputStream getOutputStream()
    Gets an `OutputStream` that can be used for storing the contents of the file.
    Specified by:
      `getOutputStream` in interface `FileItem<DiskFileItem>`
    Returns:
      An `OutputStream` that can be used for storing the contents of the file.

  - ### getPath

    public Path getPath()
    Gets the `Path` for the `FileItem`'s data's temporary location on the disk. Note that for `FileItem`s that have their data stored in memory, this method will return `null`. When handling large files, you can use `Files.move(Path,Path,CopyOption...)` to move the file to new location without copying the data, if the source and destination locations reside within the same logical volume.
    Returns:
      The data file, or `null` if the data is stored in memory.

  - ### getSize

    public long getSize()
    Gets the size of the file.
    Specified by:
      `getSize` in interface `FileItem<DiskFileItem>`
    Returns:
      The size of the file, in bytes.

  - ### getString

    public String getString()
    Gets the contents of the file as a String, using the default character encoding. This method uses `get()` to retrieve the contents of the file.

    TODO Consider making this method throw UnsupportedEncodingException.

    Specified by:
      `getString` in interface `FileItem<DiskFileItem>`
    Returns:
      The contents of the file, as a string.

  - ### getString

    public String getString(Charset charset) throws IOException
    Gets the contents of the file as a String, using the specified encoding. This method uses `get()` to retrieve the contents of the file.
    Specified by:
      `getString` in interface `FileItem<DiskFileItem>`
    Parameters:
      `charset` - The charset to use.
    Returns:
      The contents of the file, as a string.
    Throws:
      `IOException` - if an I/O error occurs

  - ### getTempFile

    protected Path getTempFile()
    Creates and returns a `File` representing a uniquely named temporary file in the configured repository path. The lifetime of the file is tied to the lifetime of the `FileItem` instance; the file will be deleted when the instance is garbage collected.

    Note: Subclasses that override this method must ensure that they return the same File each time.

    Returns:
      The `File` to be used for temporary storage.

  - ### isFormField

    public boolean isFormField()
    Tests whether or not a `FileItem` instance represents a simple form field.
    Specified by:
      `isFormField` in interface `FileItem<DiskFileItem>`
    Returns:
      `true` if the instance represents a simple form field; `false` if it represents an uploaded file.
    See Also:
      - `setFormField(boolean)`

  - ### isInMemory

    public boolean isInMemory()
    Provides a hint as to whether or not the file contents will be read from memory.
    Specified by:
      `isInMemory` in interface `FileItem<DiskFileItem>`
    Returns:
      `true` if the file contents will be read from memory; `false` otherwise.

  - ### setCharsetDefault

    public DiskFileItem setCharsetDefault(Charset charset)
    Sets the default charset for use when no explicit charset parameter is provided by the sender.
    Parameters:
      `charset` - the default charset
    Returns:
      this

  - ### setFieldName

    public DiskFileItem setFieldName(String fieldName)
    Sets the field name used to reference this file item.
    Specified by:
      `setFieldName` in interface `FileItem<DiskFileItem>`
    Parameters:
      `fieldName` - The name of the form field.
    Returns:
      this
    See Also:
      - `getFieldName()`

  - ### setFormField

    public DiskFileItem setFormField(boolean state)
    Specifies whether or not a `FileItem` instance represents a simple form field.
    Specified by:
      `setFormField` in interface `FileItem<DiskFileItem>`
    Parameters:
      `state` - `true` if the instance represents a simple form field; `false` if it represents an uploaded file.
    Returns:
      this
    See Also:
      - `isFormField()`

  - ### setHeaders

    public DiskFileItem setHeaders(FileItemHeaders headers)
    Sets the file item headers.
    Specified by:
      `setHeaders` in interface `FileItemHeadersProvider<DiskFileItem>`
    Parameters:
      `headers` - The file items headers.
    Returns:
      this

  - ### toString

    public String toString()
    Returns a string representation of this object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this object.

  - ### write

    public DiskFileItem write(Path file) throws IOException
    Writes an uploaded item to disk.

    The client code is not concerned with whether or not the item is stored in memory, or on disk in a temporary location. They just want to write the uploaded item to a file.

    This implementation first attempts to rename the uploaded item to the specified destination file, if the item was originally written to disk. Otherwise, the data will be copied to the specified file.

    This method is only guaranteed to work once, the first time it is invoked for a particular item. This is because, in the event that the method renames a temporary file, that file will no longer be available to copy or rename again at a later time.

    Specified by:
      `write` in interface `FileItem<DiskFileItem>`
    Parameters:
      `file` - The `File` into which the uploaded item should be stored.
    Returns:
      this
    Throws:
      `IOException` - if an error occurs.